// asyncProducer.cpp : Implementation of CasyncProducer
#include "stdafx.h"
#include "Asyncserver.h"
#include "asyncProducer.h"

/////////////////////////////////////////////////////////////////////////////
// CasyncProducer

STDMETHODIMP CasyncProducer::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IasyncProducer
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CasyncProducer::GetAsyncData(BSTR *pbstrData)
{
	for(int n=0; n<8; n++)
		Sleep(1000);

	*pbstrData=::SysAllocString(L"ASync Data Returned!");

	return S_OK;
}

